package com.qq.lezi2012.cmslite.controller;

import com.qq.lezi2012.cmslite.AppProperties;
import com.qq.lezi2012.cmslite.model.CommonCallback;
import com.qq.lezi2012.cmslite.model.def.Def;
import com.qq.lezi2012.cmslite.model.def.ResponseCode;
import com.qq.lezi2012.cmslite.model.exception.BaseException;
import com.qq.lezi2012.cmslite.model.exception.BizException;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import com.qq.lezi2012.cmslite.service.CategoryService;
import com.qq.lezi2012.cmslite.service.ContentService;
import com.qq.lezi2012.cmslite.service.UserService;
import com.qq.lezi2012.cmslite.service.WidgetCodeService;
import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.http.HttpServletRequest;
import java.util.UUID;


public class BaseController {

    @Autowired
    public ContentService contentService;


    @Autowired
    public CategoryService categoryService;

    @Autowired
    public WidgetCodeService widgetCodeService;


    @Autowired
    public UserService userService;


    @Autowired
    public AppProperties appProperties;

    public Object execute(CommonCallback commonCallback) {
        BaseResponse response = new BaseResponse();
        try {
            response.result = commonCallback.exec();
        } catch (BaseException e) {

            response.respondTo(e);
        } catch (Exception e) {
            response.respondTo(ResponseCode.SYS_ERROR);
        }
        return response;
    }

    protected String uuid() {
        return UUID.randomUUID().toString().replaceAll("-", "");
    }


    protected boolean isPost(HttpServletRequest request) {
        return request.getMethod().equalsIgnoreCase("POST");
    }

    protected String sessionUserId(HttpServletRequest request) {
        String userId = (String) request.getSession().getAttribute(Def.USER_SESSION_KEY);
        return userId == null ? "-1" : userId;
    }

    protected void checkResponse(BaseResponse response) throws BizException {
        if (!response.success())
            bizError(response.code);
    }

    protected void bizError(ResponseCode responseCode) throws BizException {
        throw new BizException(responseCode);
    }

}
