package com.qq.lezi2012.cmslite.controller;


import com.qq.lezi2012.cmslite.domain.Category;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import org.apache.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

@Controller
@RequestMapping(value = "/manage/category")
public class CategoryController extends BaseController {

    private static Logger LOGGER = Logger.getLogger(CategoryController.class);

    @RequestMapping(value = "/index")
    public String index(ModelMap modelMap) {
        BaseResponse baseResponse = categoryService.list();
        modelMap.putAll(baseResponse.map());
        return "manage/category/index";
    }


    @RequestMapping(value = "/save")
    @ResponseBody
    public BaseResponse save(ModelMap modelMap, @ModelAttribute Category instance) {
        BaseResponse baseResponse = categoryService.update(instance);
        modelMap.putAll(baseResponse.map());
        return baseResponse;
    }

    @RequestMapping(value = "/delete")
    @ResponseBody
    public BaseResponse delete(ModelMap modelMap, String id) {
        BaseResponse baseResponse = categoryService.delete(id);
        modelMap.putAll(baseResponse.map());
        return baseResponse;
    }


    @RequestMapping(value = "/create")
    @ResponseBody
    public BaseResponse create(HttpServletRequest request) {
        Category category = new Category();
        category.setId(uuid());
        category.setName("新建的内容");
        category.setShowIndex(-1);
        BaseResponse response = categoryService.save(category);
        return response;
    }


}
