package com.qq.lezi2012.cmslite.controller;


import com.google.common.collect.ImmutableMap;
import com.qq.lezi2012.cmslite.AppProperties;
import com.qq.lezi2012.cmslite.domain.Category;
import com.qq.lezi2012.cmslite.domain.Content;
import com.qq.lezi2012.cmslite.domain.ContentExample;
import com.qq.lezi2012.cmslite.domain.CustContentExample;
import com.qq.lezi2012.cmslite.model.def.ContentShowType;
import com.qq.lezi2012.cmslite.model.def.ContentStatus;
import com.qq.lezi2012.cmslite.model.def.Def;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import com.qq.lezi2012.cmslite.model.vo.Pager;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import sun.java2d.loops.CustomComponent;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@RequestMapping(value = "/manage/content")
public class ContentController extends BaseController {


    @RequestMapping(value = "/save")
    public String save(@ModelAttribute Content instance, ModelMap modelMap) {
        instance.setUpdatedAt(new Date());
        instance.setContent(instance.getContent().replaceAll(AppProperties.instance.uploadRootUrl, "_fix_"));
        contentService.update(instance);
        return "redirect:/manage/content/contentOpt/" + instance.getId();
    }

    @RequestMapping(value = "/updatePics/{contentId}")
    @ResponseBody
    public String uploadPic(@PathVariable String contentId, HttpServletRequest request) {
        StringBuffer stringBuffer = new StringBuffer("[");
        try {
            /**
             * 获得page 的存储路径 = 存储跟路径 + page 生成日期 + id
             * like /Library/WebServer/Documents/upload/2015/05/03/6ff3e27b-c628-4dc9-ad09-ec58e850bf67
             *
             * @param page
             * @return
             */

            BaseResponse contentResponse = contentService.get(contentId);

            Content content = (Content) contentResponse.result;


            String pageUploadPath = contentService.getContentUploadPath(content);


            //--------------------- 校验存储路径 ----------------------
            File uploadPath = new File(pageUploadPath);
            if (!uploadPath.isDirectory()) {
                uploadPath.mkdirs();
            }

            // --------------------- 文件上传 -----------------------------------


            FileItemFactory factory = new DiskFileItemFactory();//为该请求创建一个DiskFileItemFactory对象，通过它来解析请求。执行解析后，所有的表单项目都保存在一个List中。
            ServletFileUpload upload = new ServletFileUpload(factory);
            List<FileItem> items = upload.parseRequest(request);
            Iterator<FileItem> itr = items.iterator();
            List urlList = new ArrayList();


            while (itr.hasNext()) {
                String picFile = pageUploadPath + "/" + uuid() + ".png";
                FileItem fileItem = (FileItem) itr.next();
                String fileName = fileItem.getFieldName();
                File savedFile = new File(picFile);
                fileItem.write(savedFile);
                String url = picFile.replaceAll(appProperties.uploadRootDir, appProperties.uploadRootUrl);
                urlList.add(url);

            }


            // --------------------- 返回给ck editor -----------------------------------

            boolean isFirst = true;
            for (int i = 0; i < urlList.size(); i++) {
                if (isFirst) {
                    isFirst = false;
                } else {
                    stringBuffer.append(",");
                }
                stringBuffer.append("'");
                stringBuffer.append(urlList.get(i));
                stringBuffer.append("'");

            }
            stringBuffer.append("]");

        } catch (Exception e) {
            e.printStackTrace();
        }

        return stringBuffer.toString();
    }

    @RequestMapping(value = "/delete/{id}")
    @ResponseBody
    public BaseResponse delete(@PathVariable String id) {
        return contentService.delete(id);
    }


    @RequestMapping(value = "/contentOpt/{id}")
    public String contentOpt(@PathVariable String id, ModelMap modelMap) {
        modelMap.putAll(contentService.get(id).map());
        return "manage/content/contentOpt";
    }

    @RequestMapping(value = "/edit/{id}")
    public String edit(@PathVariable String id, ModelMap modelMap) {
        modelMap.putAll(contentService.get(id).map());

        BaseResponse baseResponse = categoryService.list();
        modelMap.put("categories", baseResponse.result);

        return "manage/content/edit";
    }


    @RequestMapping(value = "/index/{offsetCategoryIdStatus}")
    public String index(ModelMap modelMap, @PathVariable String offsetCategoryIdStatus) {
        BaseResponse baseResponse = categoryService.list();

        List<Category> categories = (List<Category>) baseResponse.result;
        if (categories == null || categories.size() == 0)
            return "redirect:/manage/category/index";

        modelMap.put("categories", categories);

        if (offsetCategoryIdStatus.equals("0")) {
            offsetCategoryIdStatus = "0-NONE-" + 0;
        }


        String[] parts = offsetCategoryIdStatus.split("-");

        Integer offset = Integer.parseInt(parts[0]);
        String categoryId = parts[1];
        Integer status = Integer.parseInt(parts[2]);


        CustContentExample custContentExample = new CustContentExample();
        custContentExample.setOrderByClause("CREATED_AT DESC");
        custContentExample.setOffset(offset);
        custContentExample.setLimit(appProperties.contentListSize);
        ContentExample.Criteria criteria = custContentExample.createCriteria();

        if (!"NONE".equals(categoryId))
            criteria.andCategoryIdEqualTo(categoryId);
        if (0 != status)
            criteria.andStatusEqualTo(status);

        BaseResponse listResponse = contentService.getContentList(custContentExample);
        modelMap.putAll((Map) listResponse.result);
        modelMap.putAll(ImmutableMap.of("offset", offset, "categoryId", categoryId, "status", status));
        return "manage/content/index";
    }


    @RequestMapping(value = "/search")
    public String search(HttpServletRequest request, ModelMap modelMap, @ModelAttribute Content content) {
        BaseResponse baseResponse = categoryService.list();
        modelMap.put("categories", baseResponse.result);
        modelMap.put("content", content);


        if (isPost(request)) {
            CustContentExample custContentExample = new CustContentExample();
            custContentExample.setLimit(30);
            custContentExample.setOffset(0);
            ContentExample.Criteria criteria = custContentExample.createCriteria();
            if (StringUtils.isNotBlank(content.getTitle())) {
                criteria.andTitleLike("%" + content.getTitle() + "%");
            }

            if (content.getStatus() != 0) {
                criteria.andStatusEqualTo(content.getStatus());
            }

            if (StringUtils.isNotBlank(content.getCategoryId())) {
                criteria.andCategoryIdEqualTo(content.getCategoryId());
            }


            BaseResponse searchResponse = contentService.getContentList(custContentExample);
            modelMap.putAll((Map) searchResponse.result);
        }

        return "manage/content/search";
    }

    @RequestMapping(value = "/create")
    public String create(HttpServletRequest request) {
        Content content = new Content();
        content.setId(uuid());
        content.setTitle("新建的内容");
        content.setContent("插入内容");
        content.setStatus(ContentStatus.DRAFT.status);
        content.setShowType(ContentShowType.ALL.code);
        content.setCategoryId(Def.CATEGORY_NONE);
        content.setCreatorId(sessionUserId(request));
        content.setCreatedAt(new Date());
        contentService.save(content);
        return "redirect:/manage/content/edit/" + content.getId();
    }


}
