package com.qq.lezi2012.cmslite.controller;


import com.qq.lezi2012.cmslite.domain.ContentExample;
import com.qq.lezi2012.cmslite.domain.CustContentExample;
import com.qq.lezi2012.cmslite.domain.User;
import com.qq.lezi2012.cmslite.domain.UserExample;
import com.qq.lezi2012.cmslite.model.def.ContentStatus;
import com.qq.lezi2012.cmslite.model.def.Def;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
public class PortalController extends BaseController {

    @RequestMapping(value = "/view/{id}")
    public String view(@PathVariable String id, ModelMap modelMap) {
        modelMap.putAll(contentService.get(id).map());
        modelMap.putAll(getWidgetCateData());
        return "portal/view";
    }

    @RequestMapping(value = "/")
    public String home() {
        return "redirect:/index/0";
    }


    //cc rules : 列表地址规则为 "/index/"+offset+"-"+categoryId
    @RequestMapping(value = "/index/{offsetCategoryId}")
    public String index(
            @PathVariable("offsetCategoryId") String offsetCategoryId,
            ModelMap modelMap) {


        String[] parts = offsetCategoryId.split("-");
        int offset = Integer.parseInt(parts[0]);

        String categoryId = null;
        if (parts.length > 1) {
            categoryId = parts[1];
        }
        modelMap.put("offset", offset);
        CustContentExample contentExample = new CustContentExample();
        contentExample.setOffset(offset);
        contentExample.setLimit(appProperties.contentListSize);
        contentExample.setOrderByClause("CREATED_AT DESC");
        ContentExample.Criteria criteria = contentExample.createCriteria();
        if (StringUtils.isNotBlank(categoryId)) {
            criteria.andCategoryIdEqualTo(categoryId);

            modelMap.put("categoryId", categoryId);
        }
        criteria.andStatusEqualTo(ContentStatus.ON_LINE.status);
        BaseResponse baseResponse = contentService.getContentList(contentExample);
        modelMap.putAll((Map) baseResponse.result);
        modelMap.putAll(getWidgetCateData());
        return "portal/index";
    }


    private Map getWidgetCateData() {
        Map modelMap = new HashMap();
        modelMap.put("widgetCodes", widgetCodeService.get(null).result);
        modelMap.put("categories", categoryService.listPortalCategories().result);
        return modelMap;
    }


    @RequestMapping(value = "/login")
    public String login(HttpServletRequest request, ModelMap modelMap, @ModelAttribute User user, String code) {
        if (user == null)
            user = new User();
        String message = "";
        if (isPost(request)) {

            String sessionCaptchaCode = (String) request.getSession().getAttribute(Def.SESSION_CAPTCHA_CODE_KEY);
            if (code == null || !code.equalsIgnoreCase(sessionCaptchaCode)) {
                message = "验证码错误";
            } else {
                UserExample userExample = new UserExample();
                userExample.createCriteria().andUsernameEqualTo(user.getUsername()).andPasswordEqualTo(DigestUtils.md5Hex(user.getPassword()));

                BaseResponse baseResponse = userService.listByExample(userExample);

                List<User> users = (List<User>) baseResponse.result;
                if (users == null || users.size() == 0) {
                    message = "用户名或者密码错误";
                } else {
                    request.getSession().setAttribute(Def.USER_SESSION_KEY, users.get(0).getId());
                    return "redirect:/manage/content/index/0-NONE-0";
                }
            }
        }

        modelMap.put("message", message);
        modelMap.put("user", user);

        return "portal/login";
    }


}
