package com.qq.lezi2012.cmslite.controller;


import com.qq.lezi2012.cmslite.domain.User;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

@Controller
@RequestMapping(value = "/manage/user")
public class UserController extends BaseController {


    @RequestMapping(value = "/index")
    public String index(ModelMap modelMap) {
        BaseResponse baseResponse = userService.list();
        modelMap.putAll(baseResponse.map());
        return "manage/user/index";
    }


    @RequestMapping(value = "/logout")
    public String logout(HttpServletRequest request) {
        request.getSession().invalidate();
        return "redirect:/login";
    }


    @RequestMapping(value = "/save")
    @ResponseBody
    public BaseResponse save(ModelMap modelMap, @ModelAttribute User instance) {
        BaseResponse baseResponse = userService.update(instance);
        modelMap.putAll(baseResponse.map());
        return baseResponse;
    }

    @RequestMapping(value = "/delete")
    @ResponseBody
    public BaseResponse delete(ModelMap modelMap, String id) {
        BaseResponse baseResponse = userService.delete(id);
        modelMap.putAll(baseResponse.map());
        return baseResponse;
    }


    @RequestMapping(value = "/create")
    @ResponseBody
    public BaseResponse create(HttpServletRequest request) {
        User instance = new User();
        instance.setId(uuid());
        instance.setName("新建的用户");
        instance.setUsername("newUser-" + System.currentTimeMillis());
        instance.setPassword("123456");
        BaseResponse response = userService.save(instance);
        return response;
    }

}
