package com.qq.lezi2012.cmslite.model.vo;


import com.qq.lezi2012.cmslite.model.def.ResponseCode;
import com.qq.lezi2012.cmslite.model.exception.BaseException;

import java.util.HashMap;
import java.util.Map;

@SuppressWarnings("serial")
public class BaseResponse extends BaseVO {


    public ResponseCode code;

    public Object result;

    public Map map() {

        Map map = new HashMap();
        map.put("code", code);

        if(success())
            map.put("result", result);

        return map;
    }

    public BaseResponse() {
        this(ResponseCode.SUCCESS);
    }

    public BaseResponse(ResponseCode responseCode) {
        this.code = responseCode;
    }


    public boolean success() {
        return ResponseCode.SUCCESS.equals(this.code);
    }


    public BaseResponse(BaseException exception) {
        this.code = exception.responseCode;
    }


    public BaseResponse respondTo(ResponseCode responseCode) {
        this.code = responseCode;
        return this;
    }

    public BaseResponse respondTo(BaseException exception) {
        this.code = exception.responseCode;
        return this;
    }


}
