package com.qq.lezi2012.cmslite.model.vo;


import com.google.common.collect.ImmutableMap;

import java.util.Map;

/**
 * 用来承载翻页参数
 */
public final class Pager {
    public int offset = 0;
    public int limit = 10;
    public String sort = "CREATED_AT";
    public String order = "DESC";
    public long total;

    public Map paramMap() {
        return ImmutableMap.of(
                "offset", offset,
                "limit", limit,
                "sort", sort,
                "order", offset
        );
    }


    public boolean hasPrePage() {
        return offset != 0;
    }

    public boolean hasNextPage() {
        return offset + limit < total;
    }

    public Map oppositeOrderParamMap() {
        Map map = paramMap();
        map.put("order", "desc".equalsIgnoreCase(order) ? "asc" : "desc");
        return map;
    }


    public Map preParamMap() {
        Map map = paramMap();
        map.put("offset", offset - limit);
        return map;
    }

    public Map nextParamMap() {
        Map map = paramMap();
        map.put("offset", offset + limit);
        return map;
    }


}
