package com.qq.lezi2012.cmslite.service.impl;

import com.qq.lezi2012.cmslite.domain.Category;
import com.qq.lezi2012.cmslite.domain.CategoryExample;
import com.qq.lezi2012.cmslite.model.CommonCallback;
import com.qq.lezi2012.cmslite.model.exception.BaseException;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import com.qq.lezi2012.cmslite.service.CategoryService;
import org.springframework.stereotype.Service;

@Service
public class CategoryServiceImpl extends BaseServiceImpl implements CategoryService {
    public BaseResponse save(final Category instance) {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                categoryDao.insert(instance);
                return instance;
            }
        });
    }

    public BaseResponse update(final Category instance) {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                return categoryDao.updateByPrimaryKey(instance);
            }
        });
    }

    public BaseResponse delete(final String id) {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                return categoryDao.deleteByPrimaryKey(id);
            }
        });
    }

    public BaseResponse get(final String id) {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                return categoryDao.selectByPrimaryKey(id);
            }
        });
    }

    public BaseResponse list() {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                CategoryExample categoryExample = new CategoryExample();
                categoryExample.setOrderByClause("SHOW_INDEX asc");
                return categoryDao.selectByExample(categoryExample);
            }
        });
    }

    public BaseResponse listPortalCategories() {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                CategoryExample categoryExample = new CategoryExample();
                categoryExample.setOrderByClause("SHOW_INDEX asc");
                categoryExample.createCriteria().andShowIndexGreaterThan(0);
                return categoryDao.selectByExample(categoryExample);
            }
        });
    }
}
