package com.qq.lezi2012.cmslite.service.impl;

import com.qq.lezi2012.cmslite.domain.WidgetCode;
import com.qq.lezi2012.cmslite.domain.WidgetCodeWithBLOBs;
import com.qq.lezi2012.cmslite.model.CommonCallback;
import com.qq.lezi2012.cmslite.model.def.Def;
import com.qq.lezi2012.cmslite.model.def.ResponseCode;
import com.qq.lezi2012.cmslite.model.exception.BaseException;
import com.qq.lezi2012.cmslite.model.vo.BaseResponse;
import com.qq.lezi2012.cmslite.service.WidgetCodeService;
import org.springframework.stereotype.Service;


@Service
public class WidgetCodeServiceImpl extends BaseServiceImpl implements WidgetCodeService {
    @Override
    public BaseResponse save(final WidgetCodeWithBLOBs instance) {
        return new BaseResponse(ResponseCode.NOT_IMPL_YET);
    }

    @Override
    public BaseResponse update(final WidgetCodeWithBLOBs instance) {
        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                return widgetCodeDao.updateByPrimaryKeyWithBLOBs(instance);
            }
        });
    }

    @Override
    public BaseResponse delete(final String id) {
        return new BaseResponse(ResponseCode.NOT_IMPL_YET);
    }

    @Override
    public BaseResponse get(final String id) {

        //入参的Id 没有被使用

        return execute(new CommonCallback() {
            @Override
            public Object exec() throws BaseException {
                WidgetCodeWithBLOBs widgetCode = widgetCodeDao.selectByPrimaryKey(Def.WIDGET_RECORD_ID);

                if (widgetCode == null) {
                    widgetCode = new WidgetCodeWithBLOBs();
                    widgetCode.setId(Def.WIDGET_RECORD_ID);
                    widgetCodeDao.insert(widgetCode);
                }

                return widgetCode;
            }
        });
    }
}
