package com.qq.lezi2012.cmslite.utils;

import com.qq.lezi2012.cmslite.model.CommonCallback;
import com.qq.lezi2012.cmslite.model.def.ResponseCode;
import com.qq.lezi2012.cmslite.model.exception.BaseException;
import com.qq.lezi2012.cmslite.model.exception.SysException;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.TransactionCallback;
import org.springframework.transaction.support.TransactionTemplate;


public class TXUtils {

    public static Object withTransaction(final TransactionTemplate transactionTemplate, final CommonCallback commonCallback) throws BaseException {
        final BaseException[] exceptions = {null};
        Object obj = transactionTemplate.execute(new TransactionCallback<Object>() {
            public Object doInTransaction(TransactionStatus status) {
                try {
                    return commonCallback.exec();
                } catch (BaseException e) {
                    status.setRollbackOnly();
                    exceptions[0] = e;
                } catch (Exception e) {
                    status.setRollbackOnly();
                    SysException sysException = new SysException(ResponseCode.SYS_ERROR);
                    sysException.initCause(e);
                    exceptions[0] = sysException;
                }
                return status;
            }
        });

        if (exceptions[0] != null)
            throw exceptions[0];

        return obj;
    }

}
