package com.qq.lezi2012.cmslite.test.service;

import com.qq.lezi2012.cmslite.dao.ContentMapper;
import com.qq.lezi2012.cmslite.dao.CustContentMapper;
import com.qq.lezi2012.cmslite.domain.Content;
import com.qq.lezi2012.cmslite.domain.ContentExample;
import com.qq.lezi2012.cmslite.domain.CustContentExample;
import com.qq.lezi2012.cmslite.model.def.ContentShowType;
import com.qq.lezi2012.cmslite.model.def.ContentStatus;
import com.qq.lezi2012.cmslite.service.ContentService;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

public class ContentServiceTest extends BaseServiceTest {


    @Autowired
    public ContentService contentService;


    @Autowired
    public CustContentMapper custContentMapper;


    @Autowired
    public ContentMapper contentMapper;


    @Test
    public void delete(){
        contentService.delete("2d2834ecc80946e3bca4f1e0079f10a3");
    }


    @Test
    public void testListPage() {

        int offset = 9;
        int limit = 10;

        CustContentExample contentExample = new CustContentExample();
        contentExample.setOffset(offset);
        contentExample.setLimit(limit);
        contentExample.setOrderByClause("title desc");


        List<Content> list = custContentMapper.selectByExampleWithBLOBs(contentExample);
        for (Content content : list) {
            println(content);
        }


        int count = contentMapper.countByExample(contentExample);
        System.out.println("count = " + count);
    }


    @Test
    public void testInsert() {


        for (int i = 0; i < 50; i++) {
            Content content = new Content();
            content.setId(uuid());
            content.setStatus(ContentStatus.DRAFT.status);
            content.setShowType(ContentShowType.ALL.code);
            content.setCategoryId("1");
            content.setCreatorId(uuid());
            content.setStatus(ContentStatus.ON_LINE.status);
            content.setTitle("title - " + (i * 100));
            contentService.save(content);
        }


    }
}
